VERSION 5.00
Begin VB.Form frmMain 
   AutoRedraw      =   -1  'True
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   " Mathematical Expression Evaluator"
   ClientHeight    =   3600
   ClientLeft      =   45
   ClientTop       =   285
   ClientWidth     =   4620
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   240
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   308
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox lstExpressions 
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1530
      Left            =   60
      TabIndex        =   4
      Top             =   1380
      Width           =   4515
   End
   Begin VB.CommandButton cmdEvaluate 
      Caption         =   "Evaluate"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   3540
      TabIndex        =   1
      Top             =   660
      Width           =   1035
   End
   Begin VB.TextBox txtExpression 
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   60
      TabIndex        =   0
      Top             =   300
      Width           =   4515
   End
   Begin VB.Label lblMessage 
      BackStyle       =   0  'Transparent
      Caption         =   "The expression evaluating engine has limited syntax checking abilities.  If you have entered an expression in an invalid format then it may result in an error."
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   795
      Left            =   60
      TabIndex        =   5
      Top             =   2940
      Width           =   4515
   End
   Begin VB.Line lineLight 
      BorderColor     =   &H80000014&
      X1              =   304
      X2              =   4
      Y1              =   73
      Y2              =   73
   End
   Begin VB.Line lineDark 
      BorderColor     =   &H80000010&
      X1              =   304
      X2              =   4
      Y1              =   72
      Y2              =   72
   End
   Begin VB.Label lblExtendedInstructions 
      BackStyle       =   0  'Transparent
      Caption         =   "Or select an expression below (dblclick):"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   60
      TabIndex        =   3
      Top             =   1140
      Width           =   4515
   End
   Begin VB.Label lblInstructions 
      BackStyle       =   0  'Transparent
      Caption         =   "Type an expression:"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   60
      TabIndex        =   2
      Top             =   60
      Width           =   4515
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'********************************************************************************
'* Author:         Adam Wehmann
'* Built Using:    Visual Basic 6.0 Learning Edition
'* Created:        8/05/2002
'* Last Modified:  8/05/2002
'********************************************************************************

Option Explicit

'*******************************************************************
'* Routine:        cmdEvaluate_Click
'* Description:    Starts the evaluation of an expression.
'*******************************************************************
Private Sub cmdEvaluate_Click()
Dim strText As String
    strText = txtExpression.Text
    If strText <> "" Then
        MsgBox Evaluate_Expression(strText), vbMsgBoxSetForeground + vbInformation, "And the answer is:"
    End If
End Sub

'*******************************************************************
'* Routine:        Form_Load
'* Description:    Loads different expressions into a list.
'*******************************************************************
Private Sub Form_Load()
    With lstExpressions
        .AddItem "2+7(9-(2+6(15-13+(20-2)+4)-3)+7)"     'Answer: -877
        .AddItem "5+100/10"                             'Answer: 15
        .AddItem "99*1/3+7"                             'Answer: 40 (Approximately, 1/3 = .3 repeating...)
        .AddItem "15.2-17.3*12.2"                       'Answer: -195.86
        .AddItem "((3-1)+(1+1))((8/2)+(-2+6))-2"        'Answer: 30
        .AddItem "(2+(1+1))+4/(4-2)"                    'Answer: 6
    End With
End Sub

'*******************************************************************
'* Routine:        lstExpressions_DblClick
'* Description:    Changes the expression in the textbox.
'*******************************************************************
Private Sub lstExpressions_DblClick()
    If lstExpressions.ListIndex <> -1 Then
        txtExpression.Text = lstExpressions.List(lstExpressions.ListIndex)
    End If
End Sub

'*******************************************************************
'* Routine:        txtExpression_KeyPress
'* Description:    Allows only certain characters into textbox.
'*******************************************************************
Private Sub txtExpression_KeyPress(KeyAscii As Integer)
Dim strAllowedKeys As String
    strAllowedKeys = "0123456789.+-/*()"
    'Don't allow keys other than specified in strAllowedKeys
    If InStr(1, strAllowedKeys, Chr(KeyAscii), vbTextCompare) = 0 Then
        If KeyAscii = 13 Then
            'Evaluate expression and void key in the next conditional
            'so that there is no annoying beep noise.
        End If
        'Allow {Backspace} key to be pressed
        If KeyAscii <> 8 Then
            KeyAscii = 0
        End If
    End If
End Sub
